<template>
  <!-- 设备实时状态 -->
  <div class="leakage-cable">
    <div class="leakage-top">
      <div></div>
      <div class="operate-btn">
        <el-button type="primary" @click="refresh">刷新</el-button>
        <el-button type="primary" @click="isQuery = !isQuery">查询</el-button>
        <el-button type="primary" @click="toExport">导出</el-button>
      </div>
    </div>
    <div v-if="isQuery">
      <search @search="search" ref="reset" />
    </div>
    <el-table
      :data="tableData"
      style="width: 100%"
      :cell-class-name="cellClassFn"
      :header-cell-style="{ background: '#EAF1FE', color: '#666666' }"
    >
      <el-table-column
        prop="startPointDeviceName"
        label="网元设备(起点)"
        align="center"
      />
      <el-table-column
        prop="startPointConnectStatus_text"
        label="连接状态"
        align="center"
      />
      <el-table-column
        prop="endPointDeviceName"
        label="网元设备(终点)"
        align="center"
      />
      <el-table-column
        prop="endPointConnectStatus_text"
        label="连接状态"
        align="center"
      />
      <el-table-column
        prop="lastPointDeviceName"
        label="网元设备(末端)"
        align="center"
      />
      <el-table-column prop="uploadTime" label="上传时间" align="center" />
    </el-table>
    <Pagination
      :limit="params.size"
      :page="params.current"
      :total="total"
      class="pagination"
      @pagination="handlePageChange"
    />
  </div>
</template>

<script>
import { DeviceStatusList } from "../api";
import { ConnectStatusEnum } from "@/const/index";
import search from "./components/search.vue";
import download from "@/utils/download";
import { exportConnetTime } from "@/api/export";
import { successAlert, warningAlert } from "@/utils/alert";
export default {
  data() {
    return {
      ConnectStatusEnum,
      params: {
        current: 1,
        size: 10,
      },
      total: 10,
      tableData: [],
      isQuery: false,
      istrue:0,
      searchOption: {},
      exids: [],
    };
  },
  components: { search },
  methods: {
    // 表格背景图颜色
    cellClassFn({ row, column, rowIndex, columnIndex }) {
      if (
        row.startPointConnectStatus_text == "连接正常" &&
        column.property == "startPointConnectStatus_text"
      ) {
        return "green";
      }
      if (
        row.startPointConnectStatus_text == "连接异常" &&
        column.property == "startPointConnectStatus_text"
      ) {
        return "red";
      }
      if (
        row.endPointConnectStatus_text == "连接正常" &&
        column.property == "endPointConnectStatus_text"
      ) {
        return "green";
      } else if (
        row.endPointConnectStatus_text == "连接异常" &&
        column.property == "endPointConnectStatus_text"
      ) {
        return "red";
      }
      if (rowIndex % 2 == 1) {
        return "stripe";
      }
    },
    refresh() {
      this.$refs.reset != undefined
        ? this.$refs.reset.reset()
        : this.getTableData();
    },

    handlePageChange(pageData) {
      this.params.size = pageData.size;
      this.params.current = pageData.page;
      this.getTableData();
    },
    search(option) {
      this.istrue=1
      this.searchOption = option;
      this.getTableData();
    },
    getTableData() {
      let params = {
        ...this.params,
        ...this.searchOption,
      };
      DeviceStatusList(params).then((res) => {
        let list = res.records || [];
        list.forEach((item) => {
          item.startPointConnectStatus_text =
            this.ConnectStatusEnum[item.startPointConnectStatus];
          item.endPointConnectStatus_text =
            this.ConnectStatusEnum[item.endPointConnectStatus];
        });
        this.tableData = list;
        this.total = res.total;
        this.exids = list.map((i) => i.id);
        if (this.istrue==1) {
           if (this.tableData.length != 0) {
            successAlert("查询成功");
          } else {
            warningAlert("查询结果为空");
          }
          this.istrue=0
        }
      });
    },
    toExport() {
      if (this.exids.length == 0) {
        this.$message.warning("暂无数据");
        return false;
      } else {
        exportConnetTime({ ids: this.exids }).then((res) => {
          download(res, "vnd.ms-excel", `设备实时.xls`);
        });
      }
    },
  },
  mounted() {
    this.getTableData();
  },
};
</script>

<style lang="scss" scoped>
.leakage-cable {
  .leakage-top {
    margin-bottom: 20px;
    display: flex;
    align-items: flex-end;
    justify-content: space-between;
  }
  & ::v-deep .cell {
    color: #333333;
  }
  & ::v-deep .stripe {
    background-color: #eaf1fe;
  }
  & ::v-deep .red {
    background-color: #f00;
  }
  & ::v-deep .green {
    background-color: green;
  }
  .page {
    display: flex;
    align-items: center;
    justify-content: center;
    margin: 20px 0;
    .current {
      margin: 0 20px;
    }
  }
}
</style>
